#include "Env.Food.h"
#include "Env.World.h"
#include "Env.Settings.h"

namespace app {
  namespace env {

    // Food
    void Food::create( Vec2World IPos ) {
      Pos = IPos;
      Energy = World->EnvSettings.EnergyFromFood;

      WorldObject &Obj = World->get( Pos );

      ASSERT_THROW( Obj.Type != woNone, "createCellToNonEmptyPosition", "pos", String().pushInt( Pos.X ).pushChar( ':' ).pushInt( Pos.Y ).istr() );

      Obj.Type = woFood;
      Obj.Pos = PosInContainer;
    }
    void Food::destroy() {
      Energy = 0;

      World->get( Pos ).Type = woNone;
      World->FoodEmptyList.pushItem( PosInContainer );
    }

  }
}