#pragma once

#include "Engine.Vector.h"

#include "Env.Random.h"

namespace app {
  namespace env {

    typedef Int8 NG_t;
    typedef Int8 NG_value_t;
    typedef Int32 NG_treshold_t;

    static const NG_t NG_width = 32;
    static const NG_t NG_depth = 4;

    static const NG_value_t NG_weight_limit = 50;
    static const NG_treshold_t NG_treshold_limit = NG_weight_limit * NG_width;

    struct NeuralGridCell {

    public:
      NG_value_t Weight[ NG_width ], Value; 
      NG_treshold_t Treshold;

    };

    class NeuralGrid {

    public:
      NeuralGridCell Grid[ NG_depth ][ NG_width ];

    public:
      NeuralGrid();
      ~NeuralGrid();

    public:
      NG_value_t& input( NG_t Pos );
      NG_value_t& output( NG_t Pos );

    public:
      void step();

      void mutate( const NeuralGrid &Source, RandGen_t Seed );
      void mutate( const NeuralGrid &Source1, const NeuralGrid &Source2 ); 

    };
    
    static const UInt8 DefaultBrainFunctionListCount = 3;
    extern void ( *DefaultBrainFunctionList[ DefaultBrainFunctionListCount ] )( NeuralGrid &Target, RandGen_t Seed );
    extern const String DefaultBrainFunctionListNames[ DefaultBrainFunctionListCount ];

  }
}