#include "Env.Random.h"

#include <stdio.h>
#include <math.h>
#include <cstdlib>

namespace app {
  namespace env {

    // RandGen
    RandGen::RandGen( RandGen_t Seed /* = 0 */ ) : Seed( Seed ) {
      Increment = 0;
    }
    RandGen::~RandGen() {

    }

    // RandGen_t je unsigned int32
    RandGen_t RandGen::roll() {

      L1 = Increment++ + Seed;

      L2 = ( L1 * ( L1 + 2 ) ) / 2 + 3;
      L3 = ( L2 * ( L1 + 3 ) ) / 5 + 7;
      L4 = ( L3 * ( L1 + 5 ) ) / 11 + 13;
      L5 = ( L4 * ( L1 + 7 ) ) / 17 + 19;
      L6 = ( L5 * ( L1 + 11 ) ) / 23 + 29;
      L7 = ( L6 * ( L1 + 13 ) ) / 31 + 37;
      L8 = ( L7 * ( L1 + 17 ) ) / 41 + 43;

      Z = Seed;

      Z = Z ^ ( Z << L1 ) + L1 + Seed + 2;
      Z = Z ^ ( Z << L2 ) + L2 + Seed + 3;
      Z = Z ^ ( Z << L3 ) + L3 + Seed + 5;
      Z = Z ^ ( Z << L4 ) + L4 + Seed + 7;
      Z = Z ^ ( Z << L5 ) + L5 + Seed + 11;
      Z = Z ^ ( Z << L6 ) + L6 + Seed + 13;
      Z = Z ^ ( Z << L7 ) + L7 + Seed + 17;
      Z = Z ^ ( Z << L8 ) + L8 + Seed + 20;

      return Z;
    }
    RandGen_t RandGen::roll( RandGen_t Max ) {
      return roll() % Max;
    }

    RandGen rGen = RandGen( std::rand() );
    RandGen_t randFromSeed( RandGen_t seed ) {
      rGen.Seed = seed;
      rGen.Increment = 0;
      return rGen.roll();
    }

  }
}