#pragma once

#include "Engine.Types.h"

namespace app {
  namespace env {

    typedef UInt32 RandGen_t;

    template< typename T >
    class RandGenLimit {

    public:
      T Min, Max;

    public:
      RandGenLimit( T Min, T Max ) : Min( Min ), Max( Max ) {

      }
      RandGenLimit() : Min( 0 ), Max( 0 ) {
      }
      ~RandGenLimit() {

      }

    };

    class RandGen {

    public:
      RandGen_t L1, L2, L3, L4, L5, L6, L7, L8, Z, Increment, Seed;

    public:
      RandGen( RandGen_t Seed = 0 );
      ~RandGen();

    public:
      RandGen_t roll();
      RandGen_t roll( RandGen_t Max );

      template< typename T >
      T roll( RandGenLimit< T > Limit ) {
        return Limit.Min + roll() % ( T )( Limit.Max - Limit.Min );
      }
      template< typename T >
      T roll( T Max ) {
        return roll() % ( T )( Max );
      }

    };

    RandGen_t randFromSeed( RandGen_t seed );

  }
}