#pragma once

#include "Engine.String.h"
#include "Engine.Confix.h"
#include "Engine.Stream.h"

#include "Env.Cell.h"

namespace app {
  namespace env {

    struct Settings {

    public:
      bool WindowOpen;

    public:
      CellHealth_t CellHealth, StartingEnergy;
      CellHealth_t EnergyFromFood;
      CellHealth_t EnergyForReproduction, EnergyForSex, EnergyForMovement, EnergyOverfeed, EnergyWrongAction;
      SizeT FoodInterval, StartingFood, StartCells, stepBreakpoint, mutationLevelMultiplier;

      UInt8 defaultBrainFunctionIndex;
      NeuralGrid defaultBrain;

    public:
      UInt8 WeightMutationChance, TresholdMutationChance;

    public:
      Settings();
      ~Settings();

    public:
      void load( Stream& Str );
      
      void save( Stream& Str );

    };

  }
}