#pragma once

#include "Engine.Dedicated.h"
#include "Engine.GUI.h"
#include "Engine.Time.h"

#include "GUI.Button.h"
#include "GUI.Interface.Content.h"
#include "GUI.ScrollBar.h"
#include "GUI.ComboBox.h"

#include "Env.NeuralGrid.h"
#include "Env.Cell.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    typeHash( NeuralEditor );
    class NeuralEditor : public Element, public IContent {

    public:
      ComboBox *cSaveSel;
      Button *cUpl, *cLoad, *cSave, *cThisUpl;
      ScrollBar *cSBar;

    public:
      SizeT CellPos;
      Vec2Screen Scroll, SelCell;

    public:
      bool ForceSync;
      env::Cell TempCell;
      double NeuralWeight[ env::NG_width ][ env::NG_depth ];
      StopWatch SyncWatch;

    public:
      NeuralEditor();
      virtual ~NeuralEditor();

    public:
      virtual void init( cfx::Node &Source );

    public:
      virtual void recalc();

      virtual void draw();

    public:
        void computeNeuralWeights();

    public:
      interfaceRootDef();

    };

    extern NeuralEditor *neuralEditor;

  }

}

#endif