#pragma once

#include "Engine.Scene.h"

#include "GUI.Button.h"
#include "GUI.ComboBox.h"
#include "GUI.Label.h"

#include "Env.World.h"

namespace app {

  namespace scn {

    void onWorkspace_PauseClick( gui::Button &Btn );

    class Main : public Scene {

    public:
      enum DrawMode_e {
        dmNone,
        dmCreate,
        dmDestroy
      };

    public:
      gui::Button *cPlay, *cPause, *cStep;
      gui::ComboBox *cSpeed, *cSave, *cWorldSize;
      gui::Button *cToolW, *cToolC, *cToolF;

    public:
      Container< env::CellDrawData > CellDrawList;
      Container< env::FoodDrawData > FoodDrawList;
      Container< env::WallDrawData > WallDrawList;

    public:
      Vec2Screen ViewTranslate;
      DrawMode_e DrawMode;
      env::WorldObject_e DrawType;

      bool Drag;

    public:
      Main();
      ~Main();

    public:
      virtual void onLoadResources();
      virtual void onDraw2D();
      virtual void onPostDraw2D();

    };

  }

}