#include "Toolkit.Display.h"

namespace app {

  namespace ctrl {

    class Keyboard : public Device {

    public:
      Container< InputRecord* > Mapping;

    public:
      Keyboard() : Device() {
        
      }
      ~Keyboard() {

      }

    public:
      virtual void onInit( cfx::Node &Source ) {
        cfx::Node &N = global_s.Application->EngineSettings >> "KeyboardMapping";

        SizeT Pos;
        foreach_a( N.Nodes ) {
          Pos = N.Nodes[ a ]->Value.toInt();

          while( Mapping.Size <= Pos )
            Mapping.pushItem( 0 );

          ASSERT_CONTINUE( Mapping[ Pos ] != 0, "keyboardMapCollision", "keycode", &N.Nodes[ a ]->Value, "id1", &Mapping[ Pos ]->ID, "id2", &N.Nodes[ a ]->Name );

          Mapping[ Pos ] = new InputRecord( String().pushString( Name ).pushCChar( "." ).pushString( N.Nodes[ a ]->Name ) );
        }
      }
      virtual bool onHandle( SDL_Event &Event ) {
        if( Event.type != SDL_KEYDOWN && Event.type != SDL_KEYUP )
          return false;

        SizeT K = Event.key.keysym.sym;

        if( Mapping.Size <= K )
          return true;

        if( !Mapping[ K ] )
          return true;

        Mapping[ K ]->Value = ( ( Event.type == SDL_KEYUP ) ? 0.0f : 1.0f );

        return true;
      }

    };

    hook( hookRegisterInputDevices ) {
      registerDevice( Keyboard );

    }

  }

}