#include "Toolkit.Display.h"

namespace app {

  namespace ctrl {

    class Mouse : public Device {

    public:
      Container< InputRecord* > Mapping, ToRelease;
      bool Cursor;

    public:
      Mouse() : Device() {

      }
      ~Mouse() {

      }

    public:
      void _set( SizeT K, float Val ) {
        if( Mapping.Size <= K )
          return;

        if( !Mapping[ K ] )
          return;

        if( Mapping[ K ]->Value == 1.0f && Mapping[ K ]->PrevValue == 0.0f && Val == 0.0f ) 
          ToRelease.pushItem( Mapping[ K ] );
        else
          Mapping[ K ]->Value = Val;
      }

    public:
      virtual void onInit( cfx::Node &Source ) {
        Cursor = Source |= "Cursor";

        cfx::Node &N = global_s.Application->EngineSettings >> "MouseMapping";

        SizeT Pos;
        foreach_a( N.Nodes ) {
          Pos = N.Nodes[ a ]->Value.toInt();

          while( Mapping.Size <= Pos )
            Mapping.pushItem( 0 );

          ASSERT_CONTINUE( Mapping[ Pos ] != 0, "mouseMapCollision", "button", &N.Nodes[ a ]->Value, "id1", &Mapping[ Pos ]->ID, "id2", &N.Nodes[ a ]->Name );

          Mapping[ Pos ] = new InputRecord( String().pushString( Name ).pushCChar( "." ).pushString( N.Nodes[ a ]->Name ) );
        }
      }
      virtual bool onHandle( SDL_Event &Event ) {
        switch( Event.type ) {

        case SDL_MOUSEBUTTONDOWN:
          _set( Event.button.button, 1.0f );
          break;

        case SDL_MOUSEBUTTONUP:
          _set( Event.button.button, 0.0f );
          break;

        case SDL_MOUSEMOTION:
          if( Cursor ) {
            global_s.Cursor->Pos.assign( Event.motion.x, Event.motion.y );
          }
          break;
          

        default:
          return false;
          break;

        }

        return true;
      }
      virtual void onStep() {
        foreach_a( ToRelease )
          ToRelease[ a ]->Value = 0.0f;
        
        ToRelease.Size = 0;
      }

    };

    hook( hookRegisterInputDevices ) {
      registerDevice( Mouse );

    }

  }

}