#include "Engine.Application.h"
#include "Engine.Hooks.h"
#include "Engine.Exception.h"
#include "Engine.Variables.h"

#include <SDL/SDL.h>

/*#if defined(_DEBUG) && defined(_MSC_VER)
#include <crtdbg.h>
#endif
*/

namespace app {

  // IApplication
  IApplication::IApplication( UInt16 Flags ) : Thread( String( "Application" ) ), Flags( Flags ) {
    clientOnly(
      CurrentScene = 0;
      )
  }
  IApplication::~IApplication() {

  }

  void IApplication::run() {
    Thread::run_nothrd();
  }

  void IApplication::onThrdInit() {

/*#if defined(_DEBUG) && defined(_MSC_VER)
    _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_LEAK_CHECK_DF );
    //_CrtSetBreakAlloc( 3604 );
#endif*/


    global_s.Application = this;    

    ASSERT_THROW( SDL_Init( SDL_INIT_EVERYTHING ) < 0, "SDLInitError", "error", &IString( SDL_GetError() ) );

    Settings.load( "../cfg/settings.cfx" );
    EngineSettings.load( "../cfg/engine.cfx" );

    HookManager.call( hookAppPreInit );
    HookManager.call( hookAppInit );
    onAppInit();
    HookManager.call( hookAppPostInit );
  }
  void IApplication::onThrdDestroy() {
    HookManager.call( hookAppPreDestroy );

    Settings.save();
    //EngineSettings.save();

    onAppDestroy();
    HookManager.call( hookAppDestroy );

    SDL_Quit();
  }
  void IApplication::onThrdStep() {
    HookManager.call( hookAppPreStep );
    HookManager.call( hookAppStep );
    onAppStep();
    HookManager.call( hookAppPostStep );

    foreach_a( ToBeDestroyed )
      delete ToBeDestroyed[ a ];
    ToBeDestroyed.clear();
  }

}