#pragma once

#pragma comment(lib, "SDL.lib")

#include "Engine.Thread.h"
#include "Engine.Confix.h"
#include "Engine.Dedicated.h"
#include "Engine.Scene.h"

namespace app {

  class ILinkedVariable;
  class IDestructible;  

  class IApplication : public Thread {

  public:
    enum eUsing : UInt16 {
      
    };

  public:
    Container< ILinkedVariable* > LinkedVariables;
    Container< IDestructible* > ToBeDestroyed;
    String WindowCaption;
    cfx::Document Settings, EngineSettings;
    UInt16 Flags;

  public:
    clientOnly(
      Scene *CurrentScene;
      )

  public:
    IApplication( UInt16 Flags );
    ~IApplication();

  public:
    void run();

  public:
    virtual void onThrdInit();
    virtual void onThrdDestroy();
    virtual void onThrdStep();

    virtual void onAppInit() {};
    virtual void onAppDestroy() {};
    virtual void onAppStep() {};

  };

}