#include "Engine.Confix.h"
#include "Engine.File.h"
#include "Engine.Exception.h"

#include <stdio.h>

namespace app {

  namespace cfx {

    static const char symValue = ':';
    static const char symArgument = '|';
    static const char symComment = '#';

    String safeString( const String &Source ) {
      /*String Str;
      Str.pushCChar( "{" );
      
      char Cr[ 100 ];

      foreach_a( Source ) {
        sprintf_danol( Cr, "%c(%i)", Source[ a ], Source[ a ] );
        Str.pushCChar( Cr );
      }

      Str.pushCChar( "}" );
      return Str;*/
      return Source;
      // TODO: Make this :D
    }

    // Argument
    Argument::Argument() {

    }
    Argument::Argument( const IString &Name, const IString &Value /* = String() */ ) : Name( Name ), Value( Value ) {

    }

    String& Argument::operator>( eCfxProperty Property ) {
      switch( Property ) {

      case cfxName:
        return Name;
        break;

      case cfxValue:
        return Value;
        break;

      default:
        return Name;
        break;

      }
    }

    void Argument::formatSave( String &Target, bool Prefix ) {
      if ( !Name.Size && !Value.Size )
        return;

      if ( Prefix )
        Target.pushChar( ' ' );

      Target.pushChar( symArgument );

      if ( Name.Size )
        Target.pushChar( ' ' ).pushString( safeString( Name ) );

      if ( Value.Size )
        Target.pushChar( symValue ).pushChar( ' ' ).pushString( safeString( Value ) );
    }

    void Argument::merge( Argument &Source, UInt8 Flags ) {
      if( Flags & cfxmOverwriteEmpty ) {
        if( !Name.Size || ( Name.Ptr[ 0 ] == '@' ) )
          Name = Source.Name;
        if( !Value.Size || ( Value.Ptr[ 0 ] == '@' ) )
          Value = Source.Value;

      }
    }

    Argument* Argument::duplicate() {
      return new Argument( Name, Value );
    }

    // Node
    Node::Node() {

    }
    Node::Node( const IString &Name, const IString &Value /* = String() */, const IString &Comment /* = String() */ ) : Name( Name ), Value( Value ), Comment( Comment ) {

    }

    Node::~Node() {
      foreach_a( Nodes )
        delete Nodes[ a ];

      foreach_a( Arguments )
        delete Arguments[ a ];
    }

    Node& Node::operator>>( const char *Name ) {
      return this->operator>>( String( Name ) );
    }
    Node& Node::operator>>( const IString &Name ) {
      foreach_a( Nodes ) {
        if ( Nodes[ a ]->Name == Name )
          return *Nodes[ a ];

      }
      
      Node *N = new Node( Name );
      Nodes.pushItem( N );

      return *N;
    }
    Node& Node::operator>>( const SizeT Pos ) {
      while( Nodes.Size <= Pos )
        Nodes.pushItem( new Node() );

      return *Nodes[ Pos ];
    }
    Node& Node::N( const IString &Name ) {
      return *this >> Name;
    }

    String& Node::operator>( const char *Name ) {
      return this->operator>>( String( Name ) ).Value;
    }
    String& Node::operator>( const IString &Name ) {
      return this->operator>>( Name ).Value;
    }
    String& Node::operator>( const SizeT Pos ) {
      while( Nodes.Size <= Pos )
        Nodes.pushItem( new Node() );

      return Nodes[ Pos ]->Value;
    }
    String& Node::NV( const IString &Name ) {
      return *this > Name;
    }

    String& Node::operator>( eCfxProperty Property ) {
      switch( Property ) {

      case cfxName:
        return Name;
        break;

      case cfxValue:
        return Value;
        break;

      case cfxComment:
        return Comment;
        break;

      default:
        return Name;
        break;

      }
    }

    Argument& Node::operator||( const char *Name ) {
      return this->operator||( String( Name ) );
    }
    Argument& Node::operator||( const IString &Name ) {
      foreach_a( Arguments ) {
        if ( Arguments[ a ]->Name == Name )
          return *Arguments[ a ];

      }

      Argument *A = new Argument( Name );
      Arguments.pushItem( A );

      return *A;
    }
    Argument& Node::operator||( const SizeT Pos ) {
      while( Arguments.Size <= Pos )
        Arguments.pushItem( new Argument() );

      return *Arguments[ Pos ];
    }
    Argument& Node::A( const IString &Name ) {
      return *this || Name;
    }

    String& Node::operator|( const char *Name ) {
      return this->operator||( String( Name ) ).Value;
    }
    String& Node::operator|( const IString &Name ) {
      return this->operator||( Name ).Value;
    }
    String& Node::operator|( const SizeT Pos ) {
      while( Arguments.Size <= Pos )
        Arguments.pushItem( new Argument() );

      return Arguments[ Pos ]->Value;
    }
    String& Node::AV( const IString &Name ) {
      return *this| Name;
    }


    bool Node::operator>=( const char *Name ) {
      return this->operator>=( String( Name ) );
    }
    bool Node::operator>=( const IString &Name ) {
      foreach_a( Nodes ) {
        if ( Nodes[ a ]->Name == Name )
          return true;

      }

      return false;
    }
    bool Node::operator>=( const SizeT Pos ) {
      return Nodes.Size > Pos;
    }

    bool Node::operator|=( const char *Name ) {
      return this->operator|=( String( Name ) );
    }
    bool Node::operator|=( const IString &Name ) {
      foreach_a( Arguments ) {
        if ( Arguments[ a ]->Name == Name )
          return true;

      }

      return false;
    }
    bool Node::operator|=( const SizeT Pos ) {
      return Arguments.Size > Pos;
    }

    Node& Node::merge( Node &Source, UInt8 Flags ) {
      if( Flags & cfxmDuplicate ) {
        foreach_a( Source.Nodes ) 
          Nodes.pushItem( Source.Nodes[ a ]->duplicate() );
        
        return *this;
      }

      if( Flags & cfxmOverwriteEmpty ) {
        if( !Name.Size || ( Name.Ptr[ 0 ] == '@' ) )
          Name = Source.Name;
        if( !Value.Size || ( Value.Ptr[ 0 ] == '@' ) )
          Value = Source.Value;
        if( !Comment.Size )
          Comment.pushString( Source.Comment );

      }

      if( Flags & cfxmNodesByPos ) {
        for( SizeT a = 0; a < mMin< SizeT >( Nodes.Size, Source.Nodes.Size ); a ++ ) 
          Nodes[ a ]->merge( *Source.Nodes[ a ], Flags );
        
        for( SizeT a = Nodes.Size; a < Source.Nodes.Size; a ++ )
          Nodes.pushItem( Source.Nodes[ a ]->duplicate() );
        
      } else {
        foreach_a( Source.Nodes ) {   
          if( Source.Nodes[ a ]->Comment == "NOMERGE" || !( *this >= Source.Nodes[ a ]->Name ) )
            Nodes.pushItem( Source.Nodes[ a ]->duplicate() );
          else {
            Node &N = *this >> Source.Nodes[ a ]->Name;
            if( N.Comment == "NOMERGE" )
              Nodes.pushItem( Source.Nodes[ a ]->duplicate() );
            else
              N.merge( *Source.Nodes[ a ], Flags );
          }
          
        }

      }

      if( Flags & cfxmArgsByName ) {
        foreach_a( Source.Arguments ) {
          if( *this |= Source.Arguments[ a ]->Name )
            ( *this || Source.Arguments[ a ]->Name ).merge( *Source.Arguments[ a ], Flags );
          else
            Arguments.pushItem( Source.Arguments[ a ]->duplicate() );

        }

      } else {
        for( SizeT a = 0; a < mMin< SizeT >( Arguments.Size, Source.Arguments.Size ); a ++ ) 
          Arguments[ a ]->merge( *Source.Arguments[ a ], Flags );

        for( SizeT a = Arguments.Size; a < Source.Arguments.Size; a ++ )
          Arguments.pushItem( Source.Arguments[ a ]->duplicate() );

      }

      return *this;
    }

    Node* Node::duplicate() {
      Node* N = new Node( Name, Value, Comment );
      foreach_a( Nodes ) {
        N->Nodes.pushItem( Nodes[ a ]->duplicate() );
      }

      foreach_a( Arguments ) {
        N->Arguments.pushItem( Arguments[ a ]->duplicate() );
      }

      return N;
    }

    void Node::clearUnalloc() {
      Name.clear();
      Value.clear();
      Comment.clear();

      foreach_a( Nodes )
        delete Nodes[ a ];

      foreach_a( Arguments )
        delete Arguments[ a ];

      Nodes.clearUnalloc();
      Arguments.clearUnalloc();
    }

    void Node::formatSave( String &Target, const IString &Prefix /* = String() */ ) {
      Target.pushString( Prefix );

      if ( Name.Size )
        Target.pushString( safeString( Name ) );
      else if ( !Value.Size && !Comment.Size && !Arguments.Size )
        Target.pushChar( '#' );

      if ( Value.Size )
        Target.pushChar( symValue ).pushChar( ' ' ).pushString( safeString( Value ) );

      foreach_a( Arguments )
        Arguments[ a ]->formatSave( Target, ( Name.Size > 0 ) || ( Value.Size > 0 ) || ( a > 0 ) );

      if ( Comment.Size ) {
        if ( Name.Size || Value.Size || Arguments.Size )
          Target.pushChar( ' ' );

        Target.pushChar( symComment ).pushChar( ' ' ).pushString( safeString( Comment ) );
      }

      Target.pushChar( '\n' );

      if ( Nodes.Size ) {
        String Pre( Prefix );
        Pre.pushCChar( "  " );

        foreach_a( Nodes )
          Nodes[ a ]->formatSave( Target, Pre );

        Target.pushChar( '\n' );
      }

    }

    void Node::debugPrintTree() {
      String S;
      formatSave( S );

      char *Ch = S.toCChar();
      printf( "%s\n", Ch );
      free( Ch );
    }

    // Document
    void Document::load( const char *File ) {
      load( IString( File ) );
    }
    void Document::load( const IString &File ) {
      Name = File;

      Value.clear();
      Tree.clear();
      Tree.pushItem( this );

      readFile( File, Value );
      Value.pushChar( 0 );

      Line = 1;
      Pos = 0;
      Ch = Value[ 0 ];
      while ( !parseNode() ) {

      }

      Value.clear();
    }

    void Document::loadString( const IString &Source ) {
      Value.clear().pushString( Source );

      Tree.clear();
      Tree.pushItem( this );

      Pos = 0;
      Ch = Value[ 0 ];
      while ( !parseNode() ) {

      }

      Value.clear();
    }

    void Document::save( const char *File ) {
      save( String( File ) );
    }
    void Document::save( const IString &File ) {
      Name = File;
      save();
    }
    void Document::save() {
      String Temp;

      foreach_a( this->Nodes )
        this->Nodes[ a ]->formatSave( Temp );

      saveFile( Name, Temp );
    }


    bool Document::parseNode() {
      N = 0;
      Offset = 0;
      if ( parseOffset() )
        return true;
      parseName();

      if ( Ch == symValue ) {
        Pos ++;
        Ch = Value[ Pos ];
        parseValue();
      }


      while( true ) {
        if ( Ch == symArgument ) {
          Pos ++;
          Ch = Value[ Pos ];
          parseArgument();
        } else if ( Ch == symValue ) {
          Pos ++;
          Ch = Value[ Pos ];
          parseArgumentValue();
        } else
          break;
      }

      if ( Ch == symComment ) {
        Pos ++;
        Ch = Value[ Pos ];
        parseComment();
      }

      if ( Ch == 10 || Ch == 13 ) {
        Pos ++;
        Line ++;
        Ch = Value[ Pos ];
        return false;
      } else
        return true;
    }
    bool Document::parseOffset() {
      SizeT PrevOffset = Offset;

      while ( true ) {
        if ( Ch == ' ' )
          Offset += 1;
        else if ( Ch == '  ' )
          Offset += 2;
        else if (
          Ch > 32
          || Ch == 10
          || Ch == 13
          || Ch == 0
          )
          break;

        Pos ++;
        Ch = Value[ Pos ];
      }
       
      if( Ch == 10 || Ch == 13 ) {
        Offset = PrevOffset;
        return false;
      }
 
      ASSERT_RETURNVAL( Offset % 2 == 1, true, "cfxWrongOffset", "file", Name.istr(), "line", String().pushInt( Line ).istr() );
      Offset /= 2;
      ASSERT_RETURNVAL( Tree.Size < Offset, true, "cfxWrongOffset", "file", Name.istr(), "line", String().pushInt( Line ).istr() );

      return false;
    }
    void Document::parseName() {
      Start = Pos;
      Blank = 0;

      while ( true ) {
       if (
          Ch == symValue
          || Ch == symArgument
          || Ch == symComment
          || Ch == 13
          || Ch == 10
          || Ch == 0
          )
          break;

        if ( Ch == ' ' || Ch == '  ' )
          Blank ++;
        else
          Blank = 0;

        Pos ++;
        Ch = Value[ Pos ];
      }

      if ( Pos == Start )
        return;

      if ( !N ) {
        N = new Node( IString( Value.Ptr + Start, Pos - Start - Blank ) );
        Tree.Size = Offset + 1;
        Tree[ Offset ]->Nodes.pushItem( N );
        Tree.pushItem( N );

        if ( Tree[ Offset ]->Nodes.Size == 2 )
          int a = 5;
      }
    }
    void Document::parseValue() {
      Start = Pos;
      Blank = 0;

      while ( true ) {
        if (
          Ch == symArgument
          || Ch == symComment
          || Ch == 10
          || Ch == 13
          || Ch == 0
          )
          break;

        if ( Ch != ' ' && Ch != '  ' )
          Blank = 0;
        else if ( Start == Pos )
          Start ++;
        else
          Blank ++;

        Pos ++;
        Ch = Value[ Pos ];
      }

      if ( Pos == Start + Blank )
        return;

      if ( !N ) {
        N = new Node();
        Tree.Size = Offset + 1;
        Tree[ Offset ]->Nodes.pushItem( N );
        Tree.pushItem( N );
      }

      N->Value.assign( Value.Ptr + Start, Pos - Start - Blank );
    }
    void Document::parseArgument() {
      Start = Pos;
      Blank = 0;

      while ( true ) {
        if (
          Ch == symArgument
          || Ch == symComment
          || Ch == symValue
          || Ch == 10
          || Ch == 13
          || Ch == 0
          )
          break;

        if ( Ch != ' ' && Ch != '  ' )
          Blank = 0;
        else if ( Start == Pos )
          Start ++;
        else
          Blank ++;

        Pos ++;
        Ch = Value[ Pos ];
      }

      if ( Pos == Start + Blank ) {
        A = 0;
        return;
      }

      if ( !N ) {
        N = new Node();
        Tree.Size = Offset + 1;
        Tree[ Offset ]->Nodes.pushItem( N );
        Tree.pushItem( N );
      }

      A = new Argument( IString( Value.Ptr + Start, Pos - Start - Blank ) );
      N->Arguments.pushItem( A );
    }
    void Document::parseArgumentValue() {
      Start = Pos;
      Blank = 0;

      while ( true ) {
        if (
          Ch == symArgument
          || Ch == symComment
          || Ch == 10
          || Ch == 13
          || Ch == 0
          )
          break;

        if ( Ch != ' ' && Ch != '  ' )
          Blank = 0;
        else if ( Start == Pos )
          Start ++;
        else
          Blank ++;

        Pos ++;
        Ch = Value[ Pos ];
      }

      if ( Pos == Start + Blank )
        return;

      if ( !N ) {
        N = new Node();
        Tree.Size = Offset + 1;
        Tree[ Offset ]->Nodes.pushItem( N );
        Tree.pushItem( N );
      }

      if ( !A ) {
        A = new Argument();
        N->Arguments.pushItem( A );
      }

      A->Value.pushString( IString( Value.Ptr + Start, Pos - Start - Blank ) );

      if ( Ch == symValue ) {
        Pos ++;
        Ch = Value[ Pos ];
        parseArgumentValue();
      }
    }
    void Document::parseComment() {
      Start = Pos;
      Blank = 0;

      while ( true ) {
        if (
          Ch == 10
          || Ch == 13
          || Ch == 0
          )
          break;

        if ( Ch != ' ' && Ch != '  ' )
          Blank = 0;
        else if ( Start == Pos )
          Start ++;
        else
          Blank ++;

        Pos ++;
        Ch = Value[ Pos ];;
      }

      /*if ( Pos == Start + Blank )
        return;*/

      if ( !N ) {
        N = new Node();
        Tree.Size = Offset + 1;
        Tree[ Offset ]->Nodes.pushItem( N );
        Tree.pushItem( N );
      }
      
      N->Comment.pushString( IString( Value.Ptr + Start, Pos - Start - Blank ) );
    }

  }

}