#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Controls.h"
#include "Engine.Vector.h"
#include "Engine.Interface.h"

#ifdef MODULE_CLIENT

namespace app {

  typeHash( IDraggedObject );
  class IDraggedObject : public Interface {

  public:
    IDraggedObject();
    virtual ~IDraggedObject();

  public:
    virtual void onDraw() {};

  };

  typeHash( CursorTarget );
  class CursorTarget : public Interface {

  public:
    virtual bool onCursorStackStep() { return false; };

    virtual bool onDragObjectDrop( IDraggedObject &Object ) { return false; };

  public:
    interfaceRootDef();

  };

  class CursorData {

  public:
    CursorData();
    ~CursorData();

  public:
    void init();
    void step();
    void draw();
    void destroy();

  public:
    Vec2Screen Pos, PrevPos, RelPos;

    Container< CursorTarget* > ObjectOnCursorStack;
    IDraggedObject *DraggedObject;

    CursorTarget *ObjectOnCursor, *ClickedObject, *PrevClickedObject;

  public:
    ctrl::Input *PrimaryInteraction, *SecondaryInteraction;
    ctrl::Input *ScrollUp, *ScrollDown;

  public:
    Vec2Screen PrimaryInteractionPos;

  };

}

#endif