#pragma once

#include "Engine.Vector.h"

namespace app {

  template< typename T, typename L >
  class Dynamic2DArray_Y {

  public:
    L YSize;
    T *Ptr;

  public:
    Dynamic2DArray_Y() {
      YSize = 0;
      Ptr = 0;
    }
    ~Dynamic2DArray_Y() {
      for( L a = 0; a < YSize; a ++ )
        delete Ptr + a;

      free( Ptr );
    }

  public:
    void allocateUpTo( L Size ) {
      if( YSize >= Size )
        return;

      Ptr = ( T* ) realloc( Ptr, sizeof( T ) * Size );

      for( L a = YSize; a < XSize; a ++ )
        new ( Ptr + a ) T();

      YSize = Size;
    }

  public:
    T& at( L Y ) {
      allocateUpTo( Y );
      return Ptr[ Y ];
    }

  };

  template< typename T, typename L >
  class Dynamic2DArray {

  public:
    L XSize;
    Dynamic2DArray_Y *Ptr;

  public:
    Dynamic2DArray() {
      XSize = 0;
      Ptr = 0;
    }
    ~Dynamic2DArray() {
      for( L a = 0; a < XSize; a ++ )
        delete Ptr + a;

      free( Ptr );
    }

  public:
    void allocateUpTo( L Size ) {
      if( XSize >= Size )
        return;

      Ptr = ( T* ) realloc( Ptr, sizeof( T ) * Size );

      for( L a = XSize; a < XSize; a ++ )
        new ( Ptr + a ) Dynamic2DArray_Y();

      XSize = Size;
    }

  public:
    T& at( Vec2< L > Pos ) {
      return at( Pos.X, Pos.Y );
    }
    T& at( L X, L Y ) {
      allocateUpTo( X );
      return Ptr[ X ].at( Y );
    }

  };

}