#include "Engine.File.h"
#include "Engine.Exception.h"

#include <fstream>
#include <iostream>
#include <string>

namespace app {

  void readFile( const IString &FileName, String &Target ) {
    std::ifstream F;

    char *Ch = FileName.toCChar();
    F.open( Ch, std::ios_base::in/* | std::ios_base::binary*/ );
    free( Ch );

    ASSERT_RETURN( !F.is_open(), "fileOpenFail", "filename", &FileName );


    std::string Line;
    while( std::getline( F, Line ) ) {
      Target.Ptr = ( char* ) realloc( Target.Ptr, Target.Size + Line.size() + 1 );
      Target.Ptr[ Target.Size ] = '\n';
      memcpy( Target.Ptr + Target.Size + 1, Line.c_str(), Line.size() );
      Target.Size += Line.size() + 1;
    }
  }
  void readFile( const IString &FileName, Stream &Target ) {
    std::ifstream F;
    char *Ch = FileName.toCChar();
    F.open( Ch, std::ios_base::in | std::ios_base::binary );
    free( Ch );

    ASSERT_RETURN( !F.is_open(), "fileOpenFail", "filename", &FileName );

    F.seekg( 0, F.end );
    SizeT Size = ( SizeT ) F.tellg();
    F.seekg( 0, F.beg );

    Target.allocate( Size );
    F.read( ( char* ) Target.Ptr + Target.Size, Size );
    Target.Size += Size;
  }

  void saveFile( const IString &FileName, const IString &Source ) {
    std::ofstream F;
    char *Fn = FileName.toCChar();
    F.open( Fn, std::ios_base::out | std::ios_base::binary | std::ios_base::trunc );
    free( Fn );

    ASSERT_RETURN( !F.is_open(), "fileOpenFail", "filename", &FileName );

    F.write( Source.Ptr, Source.Size );
    F.close();
  }
  void saveFile( const IString &FileName, const Stream &Source ) {
    std::ofstream F;
    char *Fn = FileName.toCChar();
    F.open( Fn, std::ios_base::out | std::ios_base::binary | std::ios_base::trunc );
    free( Fn );

    ASSERT_RETURN( !F.is_open(), "fileOpenFail", "filename", &FileName );

    F.write( ( const char* ) Source.Ptr, Source.Size );

    F.close();
  }

  bool fileExists( const IString &FileName ) {
    std::ifstream F;
    char *Ch = FileName.toCChar();
    F.open( Ch, std::ios_base::in/* | std::ios_base::binary*/ );
    free( Ch );

    if( F.is_open() ) {
      F.close();
      return true;
    } else
      return false;
  }

}
