#pragma once

#include "Engine.OpenGL.h"
#include "Resource.Texture.h"

namespace app {

  class FrameBuffer {

  public:
    struct QueueBind {
      res::Texture *Tex;
      UInt8 Pos;
    };

  public:
    enum eAttachments {
      atDepthBuffer				= 1 << 0,
    };

  public:
    FrameBuffer();
    ~FrameBuffer();

  public:
    bool ARB;
    GLuint ID, DepthBuffer, DrawBuffers;

    UInt8 Attachments;
    Vec2Screen Size;

    Container< QueueBind > QueueBinds;

  public:
    void create( const Vec2Screen Size, UInt8 Attachments = atDepthBuffer );
    void destroy();

    void bind();
    void unbind();

    void bindTexture( res::Texture *Tex, UInt8 Pos = 0 );

  };

}