#pragma once

#pragma warning( disable: 4250 )
#pragma warning( disable: 4584 )

#include "Engine.Interface.h"
#include "Engine.Vector.h"
#include "Engine.Confix.h"
#include "Engine.Dedicated.h"
#include "Engine.Cursor.h"
#include "Engine.TypeContainer.h"

#define findInGuiDecl( RootElement, ElementName, ElementType ) if( ElementType *E = getInterfaceStatic( ElementType, ( RootElement ).find( ElementName ) ) ) 
#define findInGuiNoDecl( RootElement, ElementName, ElementType, Var ) if( Var = getInterfaceStatic( ElementType, ( RootElement ).find( ElementName ) ) ) 

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    class Root;
    class IContent;
    class ILayer;
    class Element;
    class Skin;

    enum ElementState_e : UInt8 {
      esDisabled,
      esNormal,
      esFocused,
      esHover,
      esClicked,

      _esLast
    };

    class IElement : public CursorTarget, public IDestructible {

    public:
      enum Flags_e : UInt8 {
        halCenter   = 1 << 0,
        halRight    = 1 << 1,

        valCenter   = 1 << 2,
        valBottom   = 1 << 3,

        hszRelative = 1 << 4,

        vszRelative = 1 << 5
      };

    public:
      String Name;
      Vec2Screen Pos, Size;
      Vec2Screen RealPos, RealSize;
      Vec2Screen AbsolutePos;
      UInt8 Flags;

      bool Enabled, Visible;
      ElementState_e State;

    public:
      IElement *Parent;
      ILayer *Layer;
      Root *GRoot;
      Skin *Skn;

    public:
      IElement();
      virtual ~IElement();

    public:
      virtual void init( cfx::Node &Source );

      virtual IElement* find( const IString &El );

    public:
      virtual void recalc();

      virtual void draw();

    public:
      virtual bool onCursorStackStep();

    public:
      void focus();

      ElementState_e virtualSubElementState( Vec2Screen Pos, Vec2Screen Size );

    };

    typeHash( Element );
    class Element : virtual public IElement {

    public:
      interfaceRootDef();

    };

  }

}

#endif