#pragma once

#include "settings.h"

#include "Engine.Confix.h"
#include "Engine.TypeContainer.h"

namespace app {

  // Declarations

  class IApplication;
  class Thread;

#ifdef MODULE_CLIENT
  class RenderWindow;
  class ResourceManager;
  class CursorData;

  namespace ctrl {
    class Manager;
  }
  namespace gui {
    class Element;
    class Skin;
  }

#endif

  // Structs

  struct global_s_t {

  public:
    IApplication *Application;


#ifdef MODULE_CLIENT

  public:
    RenderWindow *Display;
    ResourceManager *Resources;
    ctrl::Manager *Controls;
    CursorData *Cursor;

  public:
    struct { // gui

    public:
      cfx::Node *ColorsNode;

    public:
      Container< gui::Skin* > SkinList;

    public:
      TypeContainer< gui::Element > ElementList;
      TypeContainer< gui::Skin > SkinTypeList;

    } gui;

#endif

  };

  struct thread_t {

  public:
    Thread *Thrd;

  };

  extern global_s_t global_s;
#ifdef __MINGW32__
  extern __thread thread_t thread;
#else
  extern __declspec( thread ) thread_t thread;
#endif

}
