#pragma once

#include "Engine.Container.h"

#define hook( ID ) static void _hookFunction_ ## ID(); static const IHookRegisterer _hookRegisterer_ ## ID( ID, _hookFunction_ ## ID ); static void _hookFunction_ ## ID()
#define hookUnique( ID, UID ) static void _hookFunction_ ## ID ## _ ## UID(); static const IHookRegisterer _hookRegisterer_ ## ID ## _ ## UID( ID, _hookFunction_ ## ID ## _ ## UID ); static void _hookFunction_ ## ID ## _ ## UID()

namespace app {

  typedef void ( *HookFunction )();

  enum eSystemHooks {
    hookAppPreInit,
    hookAppInit,
    hookAppPostInit,

    hookAppPreDestroy,
    hookAppDestroy,

    hookAppPreStep, 
    hookAppStep,
    hookAppPostStep,

    hookException,

    // ------

    hookThrdInit,
    hookThrdDestroy,

    hookPostSDL_OPENGLInit,
    hookResolutionChange,

    hookRegisterInputDevices,
    hookRegisterGUIElements,
    hookRegisterGUISkins,

    _hookSystemLast
  };

  class IHookManager {

  private:
    Container< Container< HookFunction >* > Hooks;

  public:
    IHookManager();
    ~IHookManager();

  public:
    void add( SizeT ID, HookFunction Ptr );
    void call( SizeT ID );
    
  private:
    void allocate( SizeT ID );

  };

  class IHookRegisterer {

  public:
    IHookRegisterer( SizeT ID, HookFunction Func );

  };

  extern IHookManager HookManager;

}