#include "Engine.Interface.h"
#include "Engine.Exception.h"
#include "Engine.String.h"
#include "Engine.Application.h"
#include "Engine.Global.h"

#include <string.h>

namespace app {

  interfaceHashType interfaceHashFunction( const char *Source ) {   

      interfaceHashType hash = 0;
      UInt32 c;

      while( c = *( Source++ ) )
        hash = c + ( hash << 6 ) + ( hash << 16 ) - hash;

      return hash;

  }

  //FastHash
  FastHash::FastHash( const char *Sample ) {
    Hash = 0;
    char c;

    while( c = *( Sample++ ) )
      Hash = c + ( Hash << 6 ) + ( Hash << 16 ) - Hash;

  }
  FastHash::~FastHash() {

  }

  bool FastHash::operator==( const FastHash &O ) {
    return Hash == O.Hash;
  }

  // IDestructible
  IDestructible::IDestructible() {
    Released = false;
  }
  IDestructible::~IDestructible() {

  }

  bool IDestructible::destroy() {
    if( Released )
      return true;

    Released = true;
    global_s.Application->ToBeDestroyed.pushItem( this );
    return false;
  }

}