#pragma once

#include "Engine.Types.h"
#include "Engine.String.h"

#define getInterface( tp ) interfaceFuncT< tp >( tp ## _typeHash )
#define getInterfaceStatic( tp, el ) interfaceFuncTS< tp >( el, tp ## _typeHash )

#define interfaceEntry( tp ) if( H == tp ## _typeHash ) return static_cast< tp* >( this );
#define interfaceRootDef() virtual const IString getTypeName() const; virtual interfaceHashType getTypeHash() const; virtual void* interfaceFunc( interfaceHashType H )
#define interfaceRoot( class, data ) void* class::interfaceFunc( interfaceHashType H ) { interfaceEntry( class ) data return 0; }; interfaceHashType class::getTypeHash() const { return class ## _typeHash; }; const IString class::getTypeName() const { return class ## _typeName; };
#define interfaceRootLoc( class, data ) void* interfaceFunc( interfaceHashType H ) { interfaceEntry( class ) data return 0; }; interfaceHashType getTypeHash() const { return class ## _typeHash; }; const IString getTypeName() const { return class ## _typeName; }

#define typeHash( tp ) static const interfaceHashType tp ## _typeHash = interfaceHashFunction( #tp ); static const IString tp ## _typeName( #tp );

namespace app {

  typedef UInt32 interfaceHashType;

  interfaceHashType interfaceHashFunction( const char *Source );

  class _Interface {
  
  public:
    virtual void* interfaceFunc( interfaceHashType H ) = 0;
    virtual interfaceHashType getTypeHash() const = 0;
    virtual const IString getTypeName() const = 0;

    template< typename T >
    T* interfaceFuncT( interfaceHashType H ) {
      if( !this )
        return 0;

      return ( T* ) interfaceFunc( H );
    }

  };

  template< typename T >
  T* interfaceFuncTS( _Interface *El, interfaceHashType H ) {
    if( !El )
      return 0;

    return ( T* ) El->interfaceFunc( H );
  }

  class Interface: virtual public _Interface {

  };

  class FastHash {

  public:
    UInt32 Hash;

  public:
    FastHash( const char *Sample );
    ~FastHash();

  public:
    bool operator==( const FastHash &O );

  };

  class IDestructible {

  public:
    bool Released;

  public:
    IDestructible();
    virtual ~IDestructible();

  public:
    virtual bool destroy();

  };

}