#pragma once

#include <math.h>
#include <stdio.h>
#include <cstdlib>

#include "Engine.Types.h"

#undef min
#undef max
/*
#define min( a, b ) ( ( a > b ) ? b : a )
#define max( a, b ) ( ( a < b ) ? b : a )
*/
#define PIx64 3.141592
#define PIx32 3.141592f

namespace app {

  template< typename T >
  inline T mMin( T A, T B ) {
    if ( A > B )
      return B;
    else
      return A;
  };
  template< typename T >
  inline T mMax( T A, T B ) {
    if ( A < B )
      return B;
    else
      return A;
  };
  template< typename T >
  T mLimit( T A, T Min, T Max ) {
    if( A < Min )
      return Min;
    else if( A > Max )
      return Max;
    else
      return A;
  }

  template< typename T >
  inline T mRound( T A ) {
    return ( A > 0 ) ? ceil( A - 0.5 ) : floor( A + 0.5 );
  }
  template<>
  inline Float32 mRound< Float32 >( Float32 A ) {
    return ( A > 0.0f ) ? ceil( A - 0.5f ) : floor( A + 0.5f );
  }

  template< typename T >
  T mSign( T A ) {
    if( A == 0 )
      return 0;
    else if( A > 0 )
      return 1;
    else
      return -1;
  }

  template< typename T >
  inline T mRand( T Max ) {
      if( !Max )
        return 0;

      return ( T )( rand() % Max );
  }
  template<>
  inline Float32 mRand( Float32 Max ) {
    if( !Max )
      return 0;

    if( ( Float32 )( ( int ) Max ) == Max )
      return ( Float32 )( rand() % ( int )( Max ) );
    else
      return ( Float32 )( rand() % ( int )( Max * 100  ) ) / 100.0f;
  }

}
