#pragma once

#include "Engine.Vector.h"

namespace app {

  template< typename T >
  class Rec2 {

  public:
    Vec2< T > Pos, Size;

  public:
    Rec2() {

    }
    Rec2( Vec2< T > Pos, Vec2< T > Size ) : Pos( Pos ), Size( Size ) {

    }

    ~Rec2() {

    }

  public:
    bool intersects( Rec2< T > &R ) {
      return Pos.everyLess( R.Pos + R.Size ) && R.Pos.everyLess( Pos + Size );
    }
    bool intersects( Vec2< T > RPos, Vec2< T > RSize ) {
      return Pos.everyLess( RPos + RSize ) && RPos.everyLess( Pos + Size );
    }

  public:
    bool contains( Vec2< T > RPos ) {
      return RPos.everyGreaterOrEqual( Pos ) && RPos.everyLess( Pos + Size );
    }

  };

  template< typename T >
  bool Rec2Interstects( Vec2< T > Pos1, Vec2< T > Size1, Vec2< T > Pos2, Vec2< T > Size2 ) {
    return Pos1.everyLess( Pos2 + Size2 ) && Pos2.everyLess( Pos1 + Size1 );
  }

  typedef Rec2< TypeScreen > Rec2Screen;

}