#include "Engine.Scene.h"
#include "Engine.Application.h"
#include "Engine.Global.h"
#include "Engine.Resources.h"

#ifdef MODULE_CLIENT

namespace app {

  Scene::Scene( UInt16 Flags ) : Flags( Flags ) {
    Loaded = false;
  }
  Scene::~Scene() {

  }

  void Scene::activate() {
    if ( global_s.Application->CurrentScene )
      global_s.Application->CurrentScene->onDeactivate();

    global_s.Application->CurrentScene = this;
    global_s.Application->CurrentScene->onActivate();

    if ( !Loaded ) {
      onLoadResources();
      global_s.Resources->loadStandard();
      Loaded = true;
    } else {
      GUI.recalc();
    }
  }

}

#endif