#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Types.h"
#include "GUI.Root.h"
#include "Engine.Controls.h"

#ifdef MODULE_CLIENT

namespace app {

  class Scene {

  public:
    enum eUsing : UInt16 {
      using2DDraw    = 1 << 0,
      using3DDraw    = 1 << 1,
    };

  public:
    gui::Root GUI;
    ctrl::InputList Controls;
    UInt16 Flags;
    bool Loaded;

  public:
    Scene( UInt16 Flags );
    virtual ~Scene();

  public:
    void activate();

  public:
    virtual void onLoadResources() {}

    virtual void onActivate() {}
    virtual void onDeactivate() {}

    virtual void onHandle() {}
    virtual void onDraw2D() {}
    virtual void onDraw3D() {}
    virtual void onPostDraw2D() {}

  };

}

#endif