#pragma once

#include "Engine.String.h"
#include "Engine.Time.h"

#include <SDL/SDL_thread.h>
#include <SDL/SDL_mutex.h>

namespace app {

  class Mutex {

  public:
    SDL_mutex *M;

  public:
    Mutex();
    ~Mutex();

  public:
    void lock();
    void unlock();

  };

  class Thread {

  public:
    enum eState {
      stStopped,
      stRunning,
      stTerminating
    };

  public:
    String Name;
    const char *CName;
    eState Status;
    SDL_Thread *Thrd;

    PerformanceUtility Performance;
    Mutex StatusMutex;

  public:
    Thread( const String &Name );
    ~Thread();

  public:
    void run();
    void run_nothrd();
    void stop();

    void waitForStop();
    void waitForRun();

    void _runProcedure();

  public:
    virtual void onThrdInit() {};
    virtual void onThrdDestroy() {};
    virtual void onThrdStep() {};

  };

}