#pragma once

#include "Engine.Types.h"

namespace app {

  namespace time {

    typedef UInt32 type;

    type get();
    void sleep( UInt16 MS );

  }

  class PerformanceUtility {

  public:
    PerformanceUtility();
    ~PerformanceUtility();

  public:
    time::type LastTime, LastUpdate, CurrentTime, Ping, MinPing;
    UInt16 FPS, FPSC, FPSCp;
    bool OneStep;

  public:
    void init();
    bool step();
    void destroy();

    void limitFPS( UInt16 MaxFPS );
    void oneStep();

    UInt16 getFPS() const;
    UInt16 getActualFPS() const;
    time::type getPing() const;
    time::type getTime() const;

  };

  class FastWatch {

  public:
    FastWatch();
    ~FastWatch();

  protected:
    time::type Time, Loc;

  public:
    time::type get();

  };

  class StopWatch {

  public:
    StopWatch();
    ~StopWatch();

  protected:
    time::type Time;

  public:
    void reset();
    time::type get();

  };

  class PerformanceSkipLimiter {

  public:
    PerformanceSkipLimiter();
    ~PerformanceSkipLimiter();

  public:
    time::type StartTime, TargetPing, PassedPings, R;

  public:
    void init();
    void setFPS( UInt16 FPS );

    bool step();

  };


}