#pragma once

#include "Engine.String.h"
#include "Engine.Interface.h"

namespace app {

  template< typename B >
  class TypeContainerRecordBase {

  public:
    String Name;
    interfaceHashType Hash;

  public:
    virtual B* create() = 0;
    virtual TypeContainerRecordBase* duplicate( const String &Nm ) = 0;

  };

  template< typename B, typename T >
  class TypeContainerRecord : public TypeContainerRecordBase< B > {

  public:
    TypeContainerRecord( const String &Nm ) {
      this->Name = Nm;

      char *NmS = Nm.toCChar();
      this->Hash = interfaceHashFunction( NmS );
      free( NmS );
    }

  public:
    virtual B* create() {
      return new T();
    }
    virtual TypeContainerRecordBase< B >* duplicate( const String &Nm ) {
      return new TypeContainerRecord< B, T >( Nm );
    }

  };

  template< typename T >
  class TypeContainer {

  public:
    Container< TypeContainerRecordBase< T >* > Records;

  public:
    TypeContainer() {

    }
    ~TypeContainer() {
      clear();
    }

  public:
    template< typename T2 >
    void add( const String &Name ) {
      Records.pushItem( new TypeContainerRecord< T, T2 >( Name ) );
    }
    template< typename T2 >
    void add( const char *Name ) {
      add< T2 >( String( Name ) );
    }

    T* create( const String &Name ) {
      foreach_a( Records ) {
        if( Records[ a ]->Name == Name )
          return ( T* ) Records[ a ]->create();

      }

      return 0;
    }
    T* create( const interfaceHashType &Hash ) {
      foreach_a( Records ) {
        if( Records[ a ]->Hash == Hash )
          return ( T* ) Records[ a ]->create();

      }

      return 0;
    }

    bool duplicate( const String &Name, const String &NewName ) {
      foreach_a( Records ) {
        if( Records[ a ]->Name == Name ) {
          Records.pushItem( Records[ a ]->duplicate( NewName ) );
          return true;
        }
      }

      return false;
    }
    void clear() {
      foreach_a( Records )
        delete Records[ a ];

      Records.clear();
    }

  };

}
