#pragma once

#include "Engine.String.h"
#include "Engine.String.Cast.h"
#include "Engine.Global.h"
#include "Engine.Application.h"

#define linkVariable( addr, var, type ) new LinkedVariable< type >( global_s.Application->Settings >> addr, var );
#define linkEngineVariable( addr, var, type ) new LinkedVariable< type >( global_s.Application->EngineSettings >> addr, var );

namespace app {

  class ILinkedVariable {

  protected:
    ILinkedVariable() {};

  public:
    virtual ~ILinkedVariable() {};

  };

  template< typename T >
  class LinkedVariable : public ILinkedVariable {

  public:
    String &Target;
    T &Source;

  public:
    LinkedVariable( String &Target, T &Source ) : Target( Target ), Source( Source ) {
      stringTo< T >( Target, Source );

      global_s.Application->LinkedVariables.pushItem( this );
    }
    virtual ~LinkedVariable() {
      stringFrom< T >( Target, Source );
    }

  };

}