#pragma once

#include "Engine.Container.h"

namespace app {

  template< typename T >
  class ZeroBaseContainer {

  public:
    Container< T > C;

  public:
    ZeroBaseContainer() : Size( C.Size ), Ptr( C.Ptr ) {

    }
    ~ZeroBaseContainer() {

    }

  public:
    SizeT &Size;
    T *&Ptr;

    T& operator[]( SizeT Pos ) {
      return Ptr[ Pos ];
    }
    const T& operator[]( SizeT Pos ) const {
      return Ptr[ Pos ];
    }

  public:
    ZeroBaseContainer< T >& pushItem( const T &Source ) {
      for( SizeT a = 0; a < Size; a ++ ) {
        if( Ptr[ a ] == 0 ) {
          Ptr[ a ] = Source;
          return *this;
        }
      }

      C.pushItem( Source );
      return *this;
    }
    ZeroBaseContainer< T >& pushContainer( ZeroBaseContainer< T > &Source ) {
      C.pushContainer( Source.C );
    }
    ZeroBaseContainer< T >& removeItem( const T &Source ) {
      for( SizeT a = 0; a < Size; a ++ ) {
        if( Ptr[ a ] == Source ) {
          Ptr[ a ] = 0;

          while( Ptr[ Size - 1 ] == 0 )
            Size--;

          return *this;
        }
      }

      return *this;
    }
    ZeroBaseContainer< T >& removeItemPos( SizeT Pos ) {
      Ptr[ Pos ] = 0;
       
      while( Ptr[ Size - 1 ] == 0 )
        Size--;

      return *this;
    }
    ZeroBaseContainer< T >& moveItemToFront( const T &Source ) {
      for( SizeT a = 0; a < Size; a ++ ) {
        if( Ptr[ a ] == Source ) {
          if( a == 0 )
            return *this;

          memmove( Ptr + 1, Ptr, sizeof( T ) * ( Size - a ) );
          Ptr[ 0 ] = Source;
          return *this;
        }
      }

      return *this;
    }
    ZeroBaseContainer< T >& moveItemToBack( const T &Source ) {
      for( SizeT a = 0; a < Size; a ++ ) {
        if( Ptr[ a ] == Source ) {
          if( a == Size - 1 )
            return *this;

          memmove( Ptr + a, Ptr + a + 1, sizeof( T ) * ( Size - a - 1 ) );
          Ptr[ Size - 1 ] = Source;
          return *this;
        }
      }

      return *this;
    }
    ZeroBaseContainer< T >& clear() {
      C.clear();
      return *this;
    }

  };

}