#include "GUI.Button.h"

#include "Engine.Global.h"
#include "Engine.Display.h"
#include "Engine.Hooks.h"
#include "Engine.GUI.Skin.h"

#include "Resource.Font.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    hook( hookRegisterGUIElements ) {
      global_s.gui.ElementList.add< Button >( "Button" );
    }

    // Button
    Button::Button() {
       onClick = 0;
       onHold = 0;
    }
    Button::~Button() {


    }

    void Button::init( cfx::Node &Source ) {
      Element::init( Source );
      ICaption::init( Source );
    }

    void Button::recalc() {
      if( Size.X == 0 ) {
        Size.X = Skn->DefaultButtonSize.X;
        Flags &= ~hszRelative;
      }
      if( Size.Y == 0 ) {
        Size.Y = Skn->DefaultButtonSize.Y;
        Flags &= ~vszRelative;
      }

      Element::recalc(); 
    }

    void Button::draw() {
      Element::draw();

      if( global_s.Cursor->ClickedObject == this ) {

        if( onHold )
          onHold( *this );

        if( onClick && global_s.Cursor->PrevClickedObject != this )
          onClick( *this );

      }

      Skn->drawButton( AbsolutePos, RealSize, Caption, State );
    }

    interfaceRoot( Button,
      interfaceEntry( ICaption )
      interfaceEntry( Element )
      );

  }

}

#endif