#include "GUI.ComboBox.h"

#include "Engine.Global.h"
#include "Engine.Display.h"
#include "Engine.Hooks.h"
#include "Engine.GUI.Skin.h"

#include "Resource.Font.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    hook( hookRegisterGUIElements ) {
      global_s.gui.ElementList.add< ComboBox >( "ComboBox" );
    }

    // ComboBox
    void onComboBoxItemDraw( CustomDrawListBox &IListBox, UInt16 Item, Vec2Screen Pos, ElementState_e State ) {
      ComboBox &LB = *IListBox.Parent->getInterface( ComboBox );
      String &It = *LB.Items[ Item ];

      LB.Skn->drawLabel( Vec2Screen( Pos.X + 5, Pos.Y + LB.cListBox.ElementSize / 2 ), It, res::Font::valCenter );
    }

    ComboBox::ComboBox() {
      cListBox.onItemDraw = onComboBoxItemDraw;
    }
    ComboBox::~ComboBox() {
      foreach_a( Items )
        delete Items[ a ];
    }

    void ComboBox::addItem( const IString& Name ) {
      Items.pushItem( new String( Name ) );
    }

    void ComboBox::removeItem( const IString& Name ) {
      foreach_a( Items ) {
        if( *Items[ a ] == Name ) {
          delete Items[ a ];
          Items.removeItemPos( a );
          return;
        }
      }
    }
    void ComboBox::removeItem( SizeT Pos ) {
      delete Items[ Pos ];
      Items.removeItemPos( Pos );
    }

    void ComboBox::init( cfx::Node &Source ) {
      CustomDrawComboBox::init( Source );

      cListBox.ElementSize = Skn->ListBoxItemSize;

      cfx::Node &S = Source >> "Items";
      foreach_a( S.Nodes ) {
        Items.pushItem( new String( S.Nodes[ a ]->Name ) );
      }
    }

    void ComboBox::recalc() {
      CustomDrawComboBox::recalc();
    }

    void ComboBox::draw() {
      cListBox.ElementCount = Items.Size;

      CustomDrawComboBox::draw();
    }

    interfaceRoot( ComboBox,
      interfaceEntry( Element )
      interfaceEntry( CustomDrawComboBox )
      );

  }

}

#endif