#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Container.h"

#include "Engine.GUI.h"

#include "GUI.CustomDrawComboBox.h"

namespace app {

  namespace gui {

    typeHash( ComboBox );
    class ComboBox : public CustomDrawComboBox {

    public:
      Container< String* > Items;

    public:
      ComboBox();
      virtual ~ComboBox();

    public:
      void addItem( const IString& Name );

      void removeItem( const IString& Name );
      void removeItem( SizeT Pos );

    public:
      virtual void init( cfx::Node &Source );

    public:
      virtual void recalc();

      virtual void draw();

    public:
      interfaceRootDef();

    };

  }

}