#include "GUI.Interface.Content.h"

#include "Engine.Global.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    // IContent
    IContent::IContent() {

    }
    IContent::~IContent() {
      foreach_a( Children )
        delete Children[ a ];
      
    }

    void IContent::init( cfx::Node &Source ) {
      Container< cfx::Node* > &N = ( Source >> "Content" ).Nodes;

      foreach_a( N )
        load( *N[ a ] );

    }
    IElement* IContent::find( const IString &El ) {
      if( Name == El )
        return this;
      
      IElement *E;
      foreach_a( Children ) {
        E = Children[ a ]->find( El );
        if( E )
          return E;
      }

      return 0;
    }

    Element* IContent::load( cfx::Node &Source ) {
      Element *E = global_s.gui.ElementList.create( Source.Name );
      ASSERT_RETURNVAL( !E, 0, "elementTypeNotFound", "typeName", Source.Name.istr() );

      E->GRoot = this->GRoot;
      E->Parent = this;
      E->Layer = this->Layer;

      Children.pushItem( E );

      E->init( Source );

      return E;
    }

    void IContent::recalc() {
      foreach_a( Children )
        Children[ a ]->recalc();
    }

    void IContent::draw() {
      IElement *E;
      foreach_a( Children ) {
        E = Children[ a ];
        E->AbsolutePos = E->RealPos + this->AbsolutePos;
        
        if( E->Visible )
          E->draw();

      }

    }

  }

}

#endif