#include "GUI.Interface.Layer.h"
#include "GUI.Root.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    // ICaption
    ILayer::ILayer() {
      
    }
    ILayer::~ILayer() {
      GRoot->FutureLayers.removeItem( this );
    }

    void ILayer::init( cfx::Node &Source ) {

      if( IContent *C = getInterfaceStatic( IContent, Parent ) )
        C->Children.removeItem( this );

      GRoot->FutureLayers.pushItem( this );

      Layer = this;
    }

    void ILayer::draw() {
      if( State == esNormal && GRoot->FutureLayers.Size && GRoot->FutureLayers[ GRoot->FutureLayers.Size - 1 ] == this )
        State = esFocused;

      AbsolutePos = Pos;
    }

    void ILayer::focusLayer() {
      GRoot->FutureLayers.removeItem( this );
      GRoot->FutureLayers.pushItem( this );
    }

  }

}

#endif