#include "GUI.Label.h"

#include "Engine.Global.h"
#include "Engine.Display.h"
#include "Engine.Hooks.h"
#include "Engine.GUI.Skin.h"

#include "Resource.Font.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    hook( hookRegisterGUIElements ) {
      global_s.gui.ElementList.add< Label >( "Label" );
    }

    // Label
    Label::Label() {

    }
    Label::~Label() {


    }

    void Label::init( cfx::Node &Source ) {
      Element::init( Source );
      ICaption::init( Source );

      TextAlign = 0;

      cfx::Node * N;
      if( Source >= "TextAlign" )
        N = &( Source >> "TextAlign" );
      else
        N = &( Source >> "Align" );

      if( N->Value == "center" )
        TextAlign |= res::Font::halCenter;
      else if( N->Value == "right" )
        TextAlign |= res::Font::halRight;

      IString &S = ( *N || ( SizeT ) 0 ).Name;
      if( S == "center" )
        TextAlign |= res::Font::valCenter;
      else if( S == "bottom" )
        TextAlign |= res::Font::valBottom;
    }

    void Label::recalc() {
      Element::recalc(); 
    }

    void Label::draw() {
      Element::draw();

      Skn->drawLabel( AbsolutePos, Caption, TextAlign );
    }

    interfaceRoot( Label,
      interfaceEntry( ICaption )
      interfaceEntry( Element )
      );

  }

}

#endif