#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Container.h"

#include "Engine.GUI.h"

#include "GUI.CustomDrawListBox.h"

namespace app {

  namespace gui {

    typeHash( ListBox );
    class ListBox : public CustomDrawListBox {

    public:
      Container< String* > Items;

    public:
      ListBox();
      virtual ~ListBox();

    public:
      void addItem( const IString& Name );

      void removeItem( const IString& Name );
      void removeItem( SizeT Pos );

    public:
      virtual void init( cfx::Node &Source );

    public:
      virtual void recalc();

      virtual void draw();

    public:
      interfaceRootDef();

    };

  }

}