#include "GUI.Root.h"

#include "Engine.Global.h"
#include "Engine.Display.h"
#include "Engine.Hooks.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    hook( hookRegisterGUIElements ) {
      // ElementList.add< Root >( "Root" ); Hehe just kidding
    }

    // Root
    Root::Root() {
      Parent = 0;
      GRoot = this;
      Layer = this;

      FocusedElement = 0;
    }
    Root::~Root() {
      foreach_a( Layers ) 
         delete Layers[ a ];

    }

    void Root::init( cfx::Node &Source ) {
      Container< cfx::Node* > &N = Source.Nodes;

      foreach_a( N )
        load( *N[ a ] );

    }
    Element* Root::loadFromFile( const IString &FileName ) {
      cfx::Document Doc;
      Element* R;

      Doc.load( FileName );

      foreach_a( Doc.Nodes )
        R = load( *Doc.Nodes[ a ] );

      return R;
    }

    void Root::recalc() {
      RealPos = 0;
      AbsolutePos = 0;

      RealSize = global_s.Display->Resolution;

      IContent::recalc();

      foreach_a( FutureLayers )
        FutureLayers[ a ]->recalc();
    }
    bool Root::onCursorStackStep() {
      if( global_s.Cursor->PrimaryInteraction->isPress() ) {
        FocusedElement = 0;
      }

      return false;
    };

    void Root::draw() {
      //Element::draw();
      State = esNormal;

      IContent::draw();

      Layers.clear();
      Layers.pushContainer( FutureLayers );

      if( global_s.Cursor->PrimaryInteraction->isPress() )
        Layer = 0;
      foreach_a( Layers )
        Layers[ a ]->draw();
    }

    interfaceRoot( Root,
      interfaceEntry( IContent )
      interfaceEntry( Element )
      );

  }

}

#endif