#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Container.h"

#include "Engine.GUI.h"

#include "GUI.Interface.Content.h"
#include "GUI.Interface.Layer.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    typeHash( Root );
    class Root : public Element, public IContent, public ILayer {

    public:
      IElement *FocusedElement;
      Container< ILayer* > Layers, FutureLayers;

    public:
      Root();
      virtual ~Root();

    public:
      virtual void init( cfx::Node &Source );
      Element* loadFromFile( const IString &FileName );

    public:
      virtual void recalc();
      virtual bool onCursorStackStep();

      virtual void draw();

      virtual void focusLayer() {};

    public:
      interfaceRootDef();

    };

  }

}

#endif