#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Container.h"

#include "Engine.GUI.h"
#include "GUI.Interface.ValMinmax.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    typeHash( ScrollBar );
    class ScrollBar : public Element, public IValMinMax {

    public:
      Float32 BarSize, ButtonSpeed, WheelSpeed;
      bool Vertical;

    protected:
      bool Dragged;

    public:
      ScrollBar();
      virtual ~ScrollBar();

    public:
      virtual void init( cfx::Node &Source );

    public:
      virtual void recalc();

      virtual void draw();

    public:
      void doWheelControl();

    protected:
      void verticalDraw();
      void horizontalDraw();

    public:
      interfaceRootDef();

    };

  }

}

#endif