#include "GUI.Skin.Gradiental.h"
#include "Engine.String.Cast.h"
#include "Engine.Hooks.h"
#include "Engine.Global.h"

#include "Resource.Font.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    namespace skin {

      hook( hookRegisterGUISkins ) {
        global_s.gui.SkinTypeList.add< Gradiental >( "Gradiental" );
      }

      // Gradiental
      Gradiental::Gradiental() {

      }
      Gradiental::~Gradiental() {

      }

      void Gradiental::init( cfx::Node &Source ) {
        Skin::init( Source );

        cfx::Node *N, *N2;

        // StandardFont
        N = &( Source >> "StandardFont" );
        StandardFont = res::Font::get( N->Value, ( ( *N ) || ( SizeT ) 0 ).Name.toInt() );

        StandardFontFlags = 0;
        if( ( *N ) |= "shadow" )
          StandardFontFlags |= res::Font::efShadow;

        // LabelColor
        stringTo< Color >( Source > "LabelColor", LabelColor );

        // PanelData
        N = &( Source >> "Panels" );

        foreach_a( N->Nodes ) {
          N2 = N->Nodes[ a ];

          loadPanel( *N2, "Normal", a, esNormal, esNormal );
          loadPanel( *N2, "Disabled", a, esDisabled, esNormal );
          loadPanel( *N2, "Focused", a, esFocused, esNormal );
          loadPanel( *N2, "Hover", a, esHover, esFocused );
          loadPanel( *N2, "Clicked", a, esClicked, esHover );
        }
      }
      void Gradiental::loadPanel( cfx::Node &Source, const IString &Nam, SizeT Pt, UInt8 Es, UInt8 AltEs ) {
        if( Source >= Nam  ) {

          cfx::Node &N = Source >> Nam;

          stringTo< Color >( N.Value, PanelData[ Pt ][ Es ].Background1 );
          stringTo< Color >( ( N || ( SizeT ) 0 ).Name, PanelData[ Pt ][ Es ].Background2 );

          stringTo< Color >( ( N || ( SizeT ) 1 ).Name, PanelData[ Pt ][ Es ].Border );

        } else if( Es != AltEs ) {
          PanelData[ Pt ][ Es ] = PanelData[ Pt ][ AltEs ];
        } else {
          PanelData[ Pt ][ Es ].Background1.assign( 0, 0, 0, 0 );
          PanelData[ Pt ][ Es ].Background2.assign( 0, 0, 0, 0 );
          PanelData[ Pt ][ Es ].Border.assign( 0, 0, 0, 0 );
        }
      }

      Vec2Screen Gradiental::getLabelSize( const IString &Text ) {
        return StandardFont->getStringSize( Text );
      }

      void Gradiental::drawPanel( Vec2Screen Pos, Vec2Screen Size, PanelType_e Panel, ElementState_e State, bool Vertical /* = false */ ) {
        PanelData_t &PD = PanelData[ Panel ][ State ];

        if( PD.Background1.A > 0 || PD.Background2.A > 0 ) {
          glDrawRectangle( Pos + 1, Size - 2, PD.Background1, PD.Background1, PD.Background2, PD.Background2 );
          if( Vertical )
            glVertexBuffer.cycleLastNTriangles2D( 2 );
        }

        if( PD.Border.A > 0 ) 
          glDrawRectangleOutline( Pos, Size, PD.Border );
      }

      void Gradiental::drawLabel( Vec2Screen Pos, const IString &Text, UInt8 Flags, Color Col /* = Color( 0, 0, 0, 0 ) */ ) {
        if( !Col.A )
          Col = LabelColor;

        StandardFont->draw( Pos, Text, Col, Flags | StandardFontFlags );
      }

    };

  }

}

#endif