#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Color.h"
#include "Engine.Confix.h"
#include "Engine.Vector.h"

#include "Engine.GUI.Skin.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace res {

    class Font;

  }

  namespace gui {

    namespace skin {

      class Gradiental : public Skin {

      public:
        struct PanelData_t {
          Color Border, Background1, Background2;
        };

      public:
        res::Font *StandardFont;
        UInt8 StandardFontFlags;

      public:
        Color LabelColor;
        PanelData_t PanelData[ _ptLast ][ _esLast ];

      public:
        Gradiental();
        virtual ~Gradiental();

      public:
        virtual void init( cfx::Node &Source );

      private:
        void loadPanel( cfx::Node &Source, const IString &Nam, SizeT Pt, UInt8 Es, UInt8 AltEs );

      public:
        virtual Vec2Screen getLabelSize( const IString &Text ) ;

      public:
        virtual void drawPanel( Vec2Screen Pos, Vec2Screen Size, PanelType_e Panel, ElementState_e State, bool Vertical = false );
        virtual void drawLabel( Vec2Screen Pos, const IString &Text, UInt8 Flags, Color Col = Color( 0, 0, 0, 0 ) );

      };

    }

  }

}

#endif