#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Container.h"
#include "Engine.GUI.h"

#include "GUI.Interface.Caption.h"
#include "GUI.Interface.Layer.h"
#include "GUI.Interface.Content.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace gui {

    typeHash( Window );
    class Window : public Element, public ICaption, public ILayer, public IContent {

    public:
      void *EventData;
      bool Resizable;
      Vec2Screen MinSize, MaxSize, clickPoint;

      void ( *onDestroy )( Window &W );
      void ( *onDraw )( Window &W );

    public:
      Window();
      virtual ~Window();

    public:
      virtual void init( cfx::Node &Source );
      virtual bool destroy();

    public:
      virtual void recalc();

      virtual void draw();

    public:
      interfaceRootDef();

    };

  }

}

#endif