#pragma once

#include "Engine.Dedicated.h"
#include "Engine.Resources.h"
#include "Engine.OpenGL.h"

#ifdef MODULE_CLIENT

namespace app {

  namespace res {

    class Shader : public Resource {

    public:
      static const GLenum shType[];
      enum eTp {
        tpFragment,
        tpVertex,
        _tpLast
      };
      enum ePass {
        passDone,
        passCompile,
        passLoad,
        passError
      };

    public:
      String Filename;
      GLuint PrgID, ShdID[ _tpLast ];
      bool ARB;

      String Source, ShdS[ _tpLast ];
      cfx::Document Doc;

      Container< GLuint > Uniforms, Attributes;

    public:
      static Shader* get( const String &Filename );
      static String unique( const String &Filename );

      Shader( const String &Filename );
      ~Shader();

    public:
      void bind();
      void unbind();

    public:
      virtual void onLoad();
      virtual void onUnload();

    private:
      bool pCompile();
      bool pLoad();

      bool pCompileARB();
    };

  }

}

#endif